#pragma once

#define SAMPLES_PER_SECOND 44100	//+vude pouit formt MONO, 8 bit na vzorek

#include "SoundGen.h"
#include "WavFile.h"

SoundGen SoundGenerator(SAMPLES_PER_SECOND);
WavFile Wav(SAMPLES_PER_SECOND);

namespace WavGen {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;
	using namespace System::Runtime::InteropServices;

	/// <summary>
	/// Summary for Form1
	///
	/// WARNING: If you change the name of this class, you will need to change the
	///          'Resource File Name' property for the managed resource compiler tool
	///          associated with all .resx files this class depends on.  Otherwise,
	///          the designers will not be able to interact properly with localized
	///          resources associated with this form.
	/// </summary>
	public ref class Form1 : public System::Windows::Forms::Form
	{
	public:
		Form1(void)
		{
			InitializeComponent();
			//
			//TODO: Add the constructor code here
			//
		}

	protected:
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		~Form1()
		{
			if (components)
			{
				delete components;
			}
		}
	private: System::Windows::Forms::Button^  PlayButton;
	private: System::Windows::Forms::Button^  SaveButton;
	private: System::Windows::Forms::Label^  label1;
	private: System::Windows::Forms::Button^  ClearButton;
	private: System::Windows::Forms::ListBox^  Timeline;

	private: System::Windows::Forms::GroupBox^  groupBox1;
	private: System::Windows::Forms::GroupBox^  groupBox2;
	private: System::Windows::Forms::NumericUpDown^  Milliseconds;
	private: System::Windows::Forms::Label^  label2;
	private: System::Windows::Forms::Button^  AddTimeButton;
	private: System::Windows::Forms::Button^  AddSoundButton;
	private: System::Windows::Forms::NumericUpDown^  Amplitude;
	private: System::Windows::Forms::NumericUpDown^  Frequency;
	private: System::Windows::Forms::Label^  label4;
	private: System::Windows::Forms::Label^  label3;
	private: System::Windows::Forms::Button^  SampleButton;
	private: System::Windows::Forms::SaveFileDialog^  SaveFileDialog;



	protected: 
		

	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>
		System::ComponentModel::Container ^components;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			this->PlayButton = (gcnew System::Windows::Forms::Button());
			this->SaveButton = (gcnew System::Windows::Forms::Button());
			this->label1 = (gcnew System::Windows::Forms::Label());
			this->ClearButton = (gcnew System::Windows::Forms::Button());
			this->Timeline = (gcnew System::Windows::Forms::ListBox());
			this->groupBox1 = (gcnew System::Windows::Forms::GroupBox());
			this->AddTimeButton = (gcnew System::Windows::Forms::Button());
			this->label2 = (gcnew System::Windows::Forms::Label());
			this->Milliseconds = (gcnew System::Windows::Forms::NumericUpDown());
			this->groupBox2 = (gcnew System::Windows::Forms::GroupBox());
			this->AddSoundButton = (gcnew System::Windows::Forms::Button());
			this->Amplitude = (gcnew System::Windows::Forms::NumericUpDown());
			this->Frequency = (gcnew System::Windows::Forms::NumericUpDown());
			this->label4 = (gcnew System::Windows::Forms::Label());
			this->label3 = (gcnew System::Windows::Forms::Label());
			this->SampleButton = (gcnew System::Windows::Forms::Button());
			this->SaveFileDialog = (gcnew System::Windows::Forms::SaveFileDialog());
			this->groupBox1->SuspendLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->Milliseconds))->BeginInit();
			this->groupBox2->SuspendLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->Amplitude))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->Frequency))->BeginInit();
			this->SuspendLayout();
			// 
			// PlayButton
			// 
			this->PlayButton->Enabled = false;
			this->PlayButton->Location = System::Drawing::Point(15, 302);
			this->PlayButton->Name = L"PlayButton";
			this->PlayButton->Size = System::Drawing::Size(75, 23);
			this->PlayButton->TabIndex = 0;
			this->PlayButton->Text = L"Pehrt";
			this->PlayButton->UseVisualStyleBackColor = true;
			this->PlayButton->Click += gcnew System::EventHandler(this, &Form1::PlayButton_Click);
			// 
			// SaveButton
			// 
			this->SaveButton->Enabled = false;
			this->SaveButton->Location = System::Drawing::Point(96, 302);
			this->SaveButton->Name = L"SaveButton";
			this->SaveButton->Size = System::Drawing::Size(75, 23);
			this->SaveButton->TabIndex = 1;
			this->SaveButton->Text = L"Uloit...";
			this->SaveButton->UseVisualStyleBackColor = true;
			this->SaveButton->Click += gcnew System::EventHandler(this, &Form1::SaveButton_Click);
			// 
			// label1
			// 
			this->label1->AutoSize = true;
			this->label1->Location = System::Drawing::Point(12, 9);
			this->label1->Name = L"label1";
			this->label1->Size = System::Drawing::Size(106, 13);
			this->label1->TabIndex = 2;
			this->label1->Text = L"asov posloupnost:";
			// 
			// ClearButton
			// 
			this->ClearButton->Location = System::Drawing::Point(459, 302);
			this->ClearButton->Name = L"ClearButton";
			this->ClearButton->Size = System::Drawing::Size(75, 23);
			this->ClearButton->TabIndex = 3;
			this->ClearButton->Text = L"Reset";
			this->ClearButton->UseVisualStyleBackColor = true;
			this->ClearButton->Click += gcnew System::EventHandler(this, &Form1::ClearButton_Click);
			// 
			// Timeline
			// 
			this->Timeline->FormattingEnabled = true;
			this->Timeline->HorizontalScrollbar = true;
			this->Timeline->Location = System::Drawing::Point(14, 27);
			this->Timeline->Name = L"Timeline";
			this->Timeline->Size = System::Drawing::Size(298, 264);
			this->Timeline->TabIndex = 4;
			// 
			// groupBox1
			// 
			this->groupBox1->Controls->Add(this->AddTimeButton);
			this->groupBox1->Controls->Add(this->label2);
			this->groupBox1->Controls->Add(this->Milliseconds);
			this->groupBox1->Location = System::Drawing::Point(318, 25);
			this->groupBox1->Name = L"groupBox1";
			this->groupBox1->Size = System::Drawing::Size(200, 119);
			this->groupBox1->TabIndex = 5;
			this->groupBox1->TabStop = false;
			this->groupBox1->Text = L"Pidn asu na konec posloupnosti";
			// 
			// AddTimeButton
			// 
			this->AddTimeButton->Location = System::Drawing::Point(36, 72);
			this->AddTimeButton->Name = L"AddTimeButton";
			this->AddTimeButton->Size = System::Drawing::Size(85, 23);
			this->AddTimeButton->TabIndex = 2;
			this->AddTimeButton->Text = L"Pidat as";
			this->AddTimeButton->UseVisualStyleBackColor = true;
			this->AddTimeButton->Click += gcnew System::EventHandler(this, &Form1::AddTimeButton_Click);
			// 
			// label2
			// 
			this->label2->AutoSize = true;
			this->label2->Location = System::Drawing::Point(116, 40);
			this->label2->Name = L"label2";
			this->label2->Size = System::Drawing::Size(20, 13);
			this->label2->TabIndex = 1;
			this->label2->Text = L"ms";
			// 
			// Milliseconds
			// 
			this->Milliseconds->Location = System::Drawing::Point(36, 37);
			this->Milliseconds->Maximum = System::Decimal(gcnew cli::array< System::Int32 >(4) {1000000, 0, 0, 0});
			this->Milliseconds->Minimum = System::Decimal(gcnew cli::array< System::Int32 >(4) {1, 0, 0, 0});
			this->Milliseconds->Name = L"Milliseconds";
			this->Milliseconds->Size = System::Drawing::Size(75, 20);
			this->Milliseconds->TabIndex = 0;
			this->Milliseconds->TextAlign = System::Windows::Forms::HorizontalAlignment::Right;
			this->Milliseconds->ThousandsSeparator = true;
			this->Milliseconds->Value = System::Decimal(gcnew cli::array< System::Int32 >(4) {1000, 0, 0, 0});
			// 
			// groupBox2
			// 
			this->groupBox2->Controls->Add(this->AddSoundButton);
			this->groupBox2->Controls->Add(this->Amplitude);
			this->groupBox2->Controls->Add(this->Frequency);
			this->groupBox2->Controls->Add(this->label4);
			this->groupBox2->Controls->Add(this->label3);
			this->groupBox2->Location = System::Drawing::Point(318, 150);
			this->groupBox2->Name = L"groupBox2";
			this->groupBox2->Size = System::Drawing::Size(200, 139);
			this->groupBox2->TabIndex = 6;
			this->groupBox2->TabStop = false;
			this->groupBox2->Text = L"Pidn zvuku do vybranho asu";
			// 
			// AddSoundButton
			// 
			this->AddSoundButton->Enabled = false;
			this->AddSoundButton->Location = System::Drawing::Point(36, 95);
			this->AddSoundButton->Name = L"AddSoundButton";
			this->AddSoundButton->Size = System::Drawing::Size(85, 23);
			this->AddSoundButton->TabIndex = 4;
			this->AddSoundButton->Text = L"Pidat zvuk";
			this->AddSoundButton->UseVisualStyleBackColor = true;
			this->AddSoundButton->Click += gcnew System::EventHandler(this, &Form1::AddSoundButton_Click);
			// 
			// Amplitude
			// 
			this->Amplitude->Location = System::Drawing::Point(36, 60);
			this->Amplitude->Minimum = System::Decimal(gcnew cli::array< System::Int32 >(4) {1, 0, 0, 0});
			this->Amplitude->Name = L"Amplitude";
			this->Amplitude->Size = System::Drawing::Size(75, 20);
			this->Amplitude->TabIndex = 3;
			this->Amplitude->TextAlign = System::Windows::Forms::HorizontalAlignment::Right;
			this->Amplitude->Value = System::Decimal(gcnew cli::array< System::Int32 >(4) {100, 0, 0, 0});
			// 
			// Frequency
			// 
			this->Frequency->Location = System::Drawing::Point(36, 33);
			this->Frequency->Maximum = System::Decimal(gcnew cli::array< System::Int32 >(4) {20000, 0, 0, 0});
			this->Frequency->Minimum = System::Decimal(gcnew cli::array< System::Int32 >(4) {25, 0, 0, 0});
			this->Frequency->Name = L"Frequency";
			this->Frequency->Size = System::Drawing::Size(75, 20);
			this->Frequency->TabIndex = 2;
			this->Frequency->TextAlign = System::Windows::Forms::HorizontalAlignment::Right;
			this->Frequency->ThousandsSeparator = true;
			this->Frequency->Value = System::Decimal(gcnew cli::array< System::Int32 >(4) {440, 0, 0, 0});
			// 
			// label4
			// 
			this->label4->AutoSize = true;
			this->label4->Location = System::Drawing::Point(117, 62);
			this->label4->Name = L"label4";
			this->label4->Size = System::Drawing::Size(69, 13);
			this->label4->TabIndex = 1;
			this->label4->Text = L"% (amplituda)";
			// 
			// label3
			// 
			this->label3->AutoSize = true;
			this->label3->Location = System::Drawing::Point(117, 35);
			this->label3->Name = L"label3";
			this->label3->Size = System::Drawing::Size(20, 13);
			this->label3->TabIndex = 0;
			this->label3->Text = L"Hz";
			// 
			// SampleButton
			// 
			this->SampleButton->Location = System::Drawing::Point(187, 302);
			this->SampleButton->Name = L"SampleButton";
			this->SampleButton->Size = System::Drawing::Size(75, 23);
			this->SampleButton->TabIndex = 7;
			this->SampleButton->Text = L"Ukzka";
			this->SampleButton->UseVisualStyleBackColor = true;
			this->SampleButton->Click += gcnew System::EventHandler(this, &Form1::SampleButton_Click);
			// 
			// SaveFileDialog
			// 
			this->SaveFileDialog->DefaultExt = L"wav";
			this->SaveFileDialog->FileName = L"zvuk";
			this->SaveFileDialog->Filter = L"WAV soubory|*.wav";
			// 
			// Form1
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(545, 340);
			this->Controls->Add(this->SampleButton);
			this->Controls->Add(this->groupBox2);
			this->Controls->Add(this->groupBox1);
			this->Controls->Add(this->Timeline);
			this->Controls->Add(this->ClearButton);
			this->Controls->Add(this->label1);
			this->Controls->Add(this->SaveButton);
			this->Controls->Add(this->PlayButton);
			this->FormBorderStyle = System::Windows::Forms::FormBorderStyle::FixedSingle;
			this->MaximizeBox = false;
			this->Name = L"Form1";
			this->StartPosition = System::Windows::Forms::FormStartPosition::CenterScreen;
			this->Text = L"WAV genertor, (C) Radek Zapletal 2012 <radekzap@centrum.cz>";
			this->groupBox1->ResumeLayout(false);
			this->groupBox1->PerformLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->Milliseconds))->EndInit();
			this->groupBox2->ResumeLayout(false);
			this->groupBox2->PerformLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->Amplitude))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->Frequency))->EndInit();
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion
	private: System::Void PlayButton_Click(System::Object^  sender, System::EventArgs^  e) {

				Wav.Play(SoundGenerator.GetBuffer(),SoundGenerator.GetBufferLength());

			 }
	private: System::Void ClearButton_Click(System::Object^  sender, System::EventArgs^  e) {
				 
				 SoundGenerator.Clear();

				 Timeline->Items->Clear();
				 AddSoundButton->Enabled=false;
				 SaveButton->Enabled=false;
				 PlayButton->Enabled=false;
				 SampleButton->Enabled=true;
			 }
private: System::Void SaveButton_Click(System::Object^  sender, System::EventArgs^  e) {

				if(SaveFileDialog->ShowDialog(this)!=System::Windows::Forms::DialogResult::OK)
					return;

				char* file = (char*)(void*)Marshal::StringToHGlobalAnsi(SaveFileDialog->FileName);
				Wav.Save(file,SoundGenerator.GetBuffer(),SoundGenerator.GetBufferLength());
				Marshal::FreeHGlobal((IntPtr)file);
				
		 }
private: System::Void AddTimeButton_Click(System::Object^  sender, System::EventArgs^  e) {

				int milliseconds=(int)Milliseconds->Value;

				SoundGenerator.AddTimeSpace(milliseconds);
				Timeline->SelectedIndex=Timeline->Items->Add(milliseconds+" ms");

				AddSoundButton->Enabled=true;
				SaveButton->Enabled=true;
				PlayButton->Enabled=true;
				SampleButton->Enabled=false;
		 }
private: System::Void AddSoundButton_Click(System::Object^  sender, System::EventArgs^  e) {

				int frequency = (int)Frequency->Value;
				int amplitude = (int)Amplitude->Value;
				int spaceIndex = Timeline->SelectedIndex+1;

				SoundGenerator.AddSineWaveToTimeSpace(spaceIndex, (float)frequency, (float)amplitude/100.0f);
				Timeline->Items[Timeline->SelectedIndex] += ", " + frequency + " Hz " + amplitude + "%";
		 }
private: System::Void SampleButton_Click(System::Object^  sender, System::EventArgs^  e) {

				Milliseconds->Value=500;	

				Amplitude->Value=100;
				AddTimeButton->PerformClick();
				Frequency->Value=262;
				AddSoundButton->PerformClick();
				
				Amplitude->Value=75;
				AddTimeButton->PerformClick();
				Frequency->Value=330;
				AddSoundButton->PerformClick();
				
				AddTimeButton->PerformClick();
				Frequency->Value=392;
				AddSoundButton->PerformClick();
				
				AddTimeButton->PerformClick();

				Amplitude->Value=100;
				AddTimeButton->PerformClick();
				Frequency->Value=262;
				AddSoundButton->PerformClick();
				Frequency->Value=262*2;
				AddSoundButton->PerformClick();

				Amplitude->Value=75;
				AddTimeButton->PerformClick();
				Frequency->Value=330;
				AddSoundButton->PerformClick();
				Frequency->Value=330*2;
				AddSoundButton->PerformClick();

				AddTimeButton->PerformClick();
				Frequency->Value=392;
				AddSoundButton->PerformClick();
				Frequency->Value=392*2;
				AddSoundButton->PerformClick();
		 }
};
}

