#pragma once

#include <stdio.h>
#include <windows.h>
#include <mmsystem.h>
#pragma comment(lib, "winmm.lib")

class WavFile
{
public:
	WavFile(int samplesPerSecond);
	~WavFile(void);

	void Play(const BYTE* buffer, int length);
	void Save(const char* fileName, const BYTE* buffer, int length);

protected:
	WAVEFORMATEX wex;
};
